// ClassExampleDlg.h : header file
//

#pragma once
#include "afxwin.h"
#include "afxcmn.h"

#include "TsliderCtrlWithEcho.h"

#include "GraphicsAPI/GraphicsAPI.h"
			// to get the propoer D3D include files

class Td3dDrawable;
class Td3dZoomDrawable;
		// HEY!! We do not need to include Td3dDrawable.h because we DO NOT NEED to know the
		// details of what is in that class. We only need to have a forward declaration for the
		// Td3dDrawable symbol. Does this make sense? IF not, ASK!! THIS IS IMPORTANT!!

class Tworld;
class TtextureControl;

// CClassExampleDlg dialog
class CClassExampleDlg : public CDialog
{
// Construction
public:
	CClassExampleDlg(CWnd* pParent = NULL);	// standard constructor
	~CClassExampleDlg();

// Dialog Data
	enum { IDD = IDD_CLASSEXAMPLE_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual BOOL PreTranslateMessage(MSG* pMsg);			// intercept messages before they get to the message pump


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

	void LinkDrawableToD3d(UINT, Td3dDrawable*);
	void LinkControlToPlaceHolder(UINT, UINT, CDialog*);
public:

	afx_msg void OnBnClickedCancel();
	// Status Area for echoing text
	CString m_EchoArea;
	
	afx_msg void OnTimer(UINT nIDEvent);

private:


	void				EnableFillButtons(BOOL b);

	Td3dDrawable		*fDrawable;		// One D3D Output Window
	Td3dZoomDrawable	*fZoomDrawable;	
	Tworld				*fMyWorld;		// This is the world model
	LPDIRECT3D9			fD3D;			// Abstract connection to D3D output pipeline

	TtextureControl		*fTextureControl;
	
	//
	// My keyboard service functions:
	void	MyServiceOnKeyDown(UINT nChar);
	void	MyServiceOnKeyUp(UINT nChar);
};
