#ifndef  GRAPHICS_API_H
#define  GRAPHICS_API_H
#pragma once

////////////////////////////////////////////////////////////////////////////////////////
//
// Limitation with this API:
//
//
#include "../StdAfx.h"

#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <cmath>       // for cos(), sin(), and sqrt() 


#include <d3d9.h>
		// Direct 3D include file (Remember to link with d3d9.lib)

#include <d3dx9mesh.h>
		// for D3DX - classes (e.g. D3DX_VECTOR, etc.)

#include <d3dx9math.h>
		// for D3DX - math classes ... (Remember to link with d3dx9.lib)

#pragma comment(lib, "d3d9.lib")
#pragma comment(lib, "d3dx9.lib")
		// d3d basic lib and d3d extension lib


// Some <math.h> files do not define M_PI... 
// 
#ifndef M_PI
#define M_PI 3.14159265358979323846f
#endif

#ifndef M_VERY_LARGE 
#define M_VERY_LARGE 10000000.0f
#endif

// Function defined in GraphicsAPI.cpp
class Td3dDrawable;
extern void InitializeGraphicsSystem(Td3dDrawable*);

//
// export from RandNum.cpp
extern float RandomNumber(float range);
	// returns a random number in the 0<->range range.
extern float RandomNumber(float minRange, float maxRange);
	// returns a random number between minRange and maxRange
extern void RandomTriple(float minRange, float maxRange, float c[3]);
	// returns three random numbers in the c-float array

//
// This is the global function, where, when all systems are properly initialized
// this allows echoing of message to the system status area
extern void EchoToStatusArea(CString msg);

#endif
