#pragma once

#include <list>
			// STL list class


#include "TgraphicsObject.h"

using namespace std;

class TobjectList : public TgraphicsObject {
		//
		// notice TobjectList is a subclass of TgraphicsObject
		// this says, we must define all the pure virtual functions
		// defined in TgraphicsObject. More importantly, we are saying
		// TobjectList is also a TgraphicsObject, meaning we will be 
		// able to "DrawObject()" on this list ... this is a powerful
		// concept, it may not be so obvious at this point, but when
		// we start to Group/Ungroup objects, this list will become
		// a fundamental tool.
		//
		// This class will be the bases for scene graph of our later mps

	private:
			
		
	protected:

				//
				// From TgraphicsObject
				//
		virtual void 	DrawObjectGeom(Td3dDrawable&, LPDIRECT3DDEVICE9);

	public:
		
		TobjectList();
		virtual ~TobjectList();


			list<TgraphicsObject*> fTheList;
					// avoiding accessing/inquiring function nightmere
					// the actual list is exposed as a public instance

			void 	InsertObject(TgraphicsObject *obj) { fTheList.push_back(obj); }
					//
					// inserting a graphics object to the end of the list
					//

			int		ListLength() const { return int(fTheList.size()); }
			bool	ListIsEmpty() const { return fTheList.empty(); }
				
			void EraseList();
					// remove everything in the list and free up all
					// associated memory
					//

			void DeleteObject(TgraphicsObject *obj);	
					// This is an order-n deletion, will free the memory
					// of obj. Meanning caller should not refer to obj-pointer
					// after calling this function
								//

			void DeleteObjectAtIterator(list<TgraphicsObject*>::iterator &it);
					// order-1 operation, will handle the freeing of
					// TgraphicsObject, and after the deletion
					// iterator points to the next element in the list

					
					// from TgraphicsObject
			virtual void UpdateLocation();
};


///////////////////////////////////////////////////////////////////////////////////////////////
// for now, we will use TobjecList as a simple collection of graphics objects
// we will come back and revisit this list after the integration of transformation 
// information into our TgraphicsObject hierarchy, at which point, suddenly, the
// TobjectList class becomes a true TgraphicsObject!!
