#include "TmyVertex.h"
#include "Tpoint.h"
#include "Tcircle.h"

			TmyVertex Tpoint::sfV;

ImplementSimpleObjAttr(Tpoint, float, PointSize)


void Tpoint::sInitializePoint(Td3dDrawable*)
{
	sfV.fPoint.x = 0;
	sfV.fPoint.y = 0;
	sfV.fPoint.z = 0;
}

Tpoint::Tpoint() : 
	fPointSize(1.0f)
{
	// Create the collision circles ..
	CreateCollisionCircles(1);
}

Tpoint::~Tpoint() 
{
	// collision circles deletion is handled in the TgraphicsObject.cpp
}


bool 
Tpoint::IntersectsBound(
	const T2dBound &b
)
{
	return b.PointInBound( GetXformInfo().Movement() );
}

void
Tpoint::SetObjectD3DAttributes(Td3dDrawable &d, LPDIRECT3DDEVICE9 device)
{
	//
	// Calls the parent class to do its work
	Tdrawable::SetObjectD3DAttributes(d, device);
	device->SetRenderState( D3DRS_POINTSIZE, *((DWORD*)(&fPointSize)));
}

void Tpoint::DrawObjectGeom(Td3dDrawable&, LPDIRECT3DDEVICE9 d3dDevice)
{
	sfV.fColor = D3DCOLOR_COLORVALUE(fDrawColor.r, fDrawColor.g, fDrawColor.b, 0.0f);
	d3dDevice->DrawPrimitiveUP(D3DPT_POINTLIST, 1, (CONST void *)(&sfV), sizeof(TmyVertex));
}