#include "Trectangle.h"
#include "GraphicsAPI.h"
#include "TmyVertex.h"
#include "Tcircle.h"

	TmyVertex Trectangle::sfRectangleVertices[4];

void Trectangle::sInitializeRectangle(Td3dDrawable*)
{
	for (int i=0; i<4; i++) {
		sfRectangleVertices[i].fU = sfRectangleVertices[i].fV = 
		sfRectangleVertices[i].fU1 = sfRectangleVertices[i].fV1 = 0.0f;
	}
	sfRectangleVertices[3].fColor = D3DCOLOR_COLORVALUE(0.9f, 0.9f, 0.9f, 0.0);

	sfRectangleVertices[0].fPoint.x = -1.0f; 
	sfRectangleVertices[0].fPoint.y = -1.0f; 
	sfRectangleVertices[0].fPoint.z =  0.0f;
	sfRectangleVertices[0].fU1 = sfRectangleVertices[0].fU = 0;
	sfRectangleVertices[0].fV1 = sfRectangleVertices[0].fV = 1;

	sfRectangleVertices[1].fPoint.x =  1.0f;
	sfRectangleVertices[1].fPoint.y = -1.0f;
	sfRectangleVertices[1].fPoint.z =  0.0f;
	sfRectangleVertices[1].fU1 = sfRectangleVertices[1].fU = 1;
	sfRectangleVertices[1].fV1 = sfRectangleVertices[1].fV = 1;

	sfRectangleVertices[2].fPoint.x = -1.0f;
	sfRectangleVertices[2].fPoint.y =  1.0f;
	sfRectangleVertices[2].fPoint.z =  0.0f;
	sfRectangleVertices[2].fU1 = sfRectangleVertices[2].fU = 0;
	sfRectangleVertices[2].fV1 = sfRectangleVertices[2].fV = 0;

	sfRectangleVertices[3].fPoint.x =  1.0f;
	sfRectangleVertices[3].fPoint.y =  1.0f;
	sfRectangleVertices[3].fPoint.z =  0.0f;
	sfRectangleVertices[3].fU1 = sfRectangleVertices[3].fU = 1;
	sfRectangleVertices[3].fV1 = sfRectangleVertices[3].fV = 0;
}

Trectangle::Trectangle() 
{
	CreateCollisionCircles(1);
}

Trectangle::~Trectangle() 
{
	// collision circle deletion is handled by the TgraphicsObject destructor
}

bool Trectangle::IntersectsBound(
	const T2dBound &b
)
{
	const D3DXVECTOR3 &c = GetXformInfo().Movement();
	float dx = GetXformInfo().ScaleX();
	float dy = GetXformInfo().ScaleY();
	T2dBound myB(c.x-dx, c.x+dx, c.y-dy, c.y+dy);

	return b.BoundIntersect(myB);
}

void Trectangle::SetFirstPosition(
	const D3DXVECTOR3 &p)
{
	TgraphicsObject::SetFirstPosition(p);
	fXformInfo.SetScaleTo(0.0f);
}

void Trectangle::SetSecondPosition(
	const D3DXVECTOR3 &p)
{
	D3DXVECTOR3 d = fXformInfo.Movement() - p;
	fXformInfo.SetScaleTo(fabs(d.x), fabs(d.y), 1.0f);
}

void Trectangle::DrawObjectGeom(
	Td3dDrawable&,
	LPDIRECT3DDEVICE9 d3dDevice
)
{
	for (int i=0; i<2; i++) {
		sfRectangleVertices[i].fColor = D3DCOLOR_COLORVALUE(fDrawColor.r, fDrawColor.g, fDrawColor.b, 0.0f);
	}
	d3dDevice->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP, 2, (CONST void *)sfRectangleVertices, sizeof(TmyVertex));
}
