#pragma once

#include "Tfillable.h"
#include "TmyVertex.h"

//
// Just like circle, rectangle has a static vertex-set.
// 
// Trectangle implements the 
//
// 		SetFirstPosition() - set XformInfo.Move()
// 		SetSecondPosition() - compte delta X/Y from FirstPosition, and use as XformInfo:ScaleX/Y
//
//
class Trectangle : public Tfillable {
	private:
		static TmyVertex	sfRectangleVertices[4];

	protected:
			//
			// Override from TgraphicsObject
			//
		virtual void DrawObjectGeom(Td3dDrawable&, LPDIRECT3DDEVICE9);

	public:
		static void sInitializeRectangle(Td3dDrawable*);

		virtual ~Trectangle();
		Trectangle();

			// This is from TgraphicsObject ...
		virtual void SetFirstPosition(const D3DXVECTOR3 &p);
		virtual void SetSecondPosition(const D3DXVECTOR3 &p);
		virtual bool IntersectsBound(const T2dBound&);
};
