#include "Ttexture.h"

Ttexture::~Ttexture()
{
	if (fTexture != NULL)
		fTexture->Release();
}

Ttexture::Ttexture(LPDIRECT3DDEVICE9 d)
{
	fTexture = NULL;
	fD3dDevice = d;
}

void Ttexture::ActivateTexture(DWORD stage)
{
	if (fTexture == NULL)
		return;

  	// set up our texture stages for a simple texture copy...
  	// fD3dDevice->SetTextureStageState( stage, D3DTSS_COLOROP,   D3DTOP_MODULATE );
	// fD3dDevice->SetTextureStageState( stage, D3DTSS_COLOROP,   D3DTOP_SELECTARG2);
	fD3dDevice->SetTextureStageState( stage, D3DTSS_COLOROP,   D3DTOP_SELECTARG1 );
				// 
				// Refer to the D3D help, the first parameter is a number (between 0 to something)
				//
				// the second parameter can be ...
				//				D3DTSS_COLOROP
				//				D3DTSS_COLORARG1, ARG2
				//				D3DTSS_ALPHAARG1, ARG2
				//				D3DTSS_MAGFILTER, MINFILTER, MIPFILTER (more and more and tons tons more!!)
				//
				// For Stage 0,
				//
				//		Arg1 is the texture
				//		Arg2 is the color on the object

				// The third parameter can be
				//				D3DTA_TEXTURE
				//				D3DTA_DIFFUSE
				//				D3DTA_MODULATE
				//				D3DTA_SELECTARG1
				//				D3DTA_SELECTARG2 ... (more and more and tons tons more!!!)

		fD3dDevice->SetTextureStageState( stage, D3DTSS_ALPHAOP,   D3DTOP_SELECTARG1);
				// Now see, are setting the alpha channel in the texture stage, in this
				// case, we say, we _always_ want the alpha information from the file texture
				//

	fD3dDevice->SetTexture(stage, fTexture);
}

void Ttexture::DeActivateTexture(DWORD stage)
{
	//
	// Is this the right way to deactivate texture?
	//
	fD3dDevice->SetTexture(stage, NULL);

	//
	// I think this is a better way to disable texture?
	fD3dDevice->SetTextureStageState( stage, D3DTSS_COLOROP,   D3DTOP_DISABLE);
}