#include "stdafx.h"
#include "Td3dDrawable.h"

//
// The followings are from our GraphicsAPI ...
//
#include "./GraphicsAPI/GraphicsAPI.h"
#include "GraphicsAPI/TfileTexture.h"

int Td3dDrawable::CreateFileTexture(
	const CString &fileName
) 
{
	if (fD3DDevice == NULL)
		return -1;

	TfileTexture *newT = new TfileTexture(fD3DDevice, fileName);
	fTextureLibrary.Add(newT);
	return	fTextureLibrary.GetSize();
}


int Td3dDrawable::ReplaceFileTextureAt(int index, const CString &fileName)
	// if <index> is not already in the table, replace will put the new file texture
	// at the very end of the table. BECAREFUL!! What you ask the library to do may
	// not be what the library does!!
	//
	//		e.g.: library is empty, you tell the library to replaceAt(20, newFile)
	//
	//	You will get an index of 0 back!! and Entry 20 will be undefined!!
{
	int returnIndex = index;
	

	// 1. decide if this is a new creation, or if we are replacing existing entry ...
	if (index < fTextureLibrary.GetSize() ) {
		Ttexture *oldT = fTextureLibrary[index];
		delete oldT;

		TfileTexture *newT = new TfileTexture(fD3DDevice, fileName);
		fTextureLibrary.SetAtIndex(index, newT);

	} else {
		// new entry to the table
		returnIndex = CreateFileTexture(fileName);
	}
	return returnIndex;
}


int Td3dDrawable::ReplaceTextureAt(int index, Ttexture *t)
	// if <index> is not already in the table, replace will put the new file texture
	// at the very end of the table. BECAREFUL!! What you ask the library to do may
	// not be what the library does!!
	//
	//		e.g.: library is empty, you tell the library to replaceAt(20, newFile)
	//
	//	You will get an index of 0 back!! and Entry 20 will be undefined!!
{
	int returnIndex = index;
	
	// decide if this is a new creation, or if we are replacing existing entry ...
	if (index < fTextureLibrary.GetSize() ) {
		Ttexture *oldT = fTextureLibrary[index];
		delete oldT;
		fTextureLibrary.SetAtIndex(index, t);
	} else {
		// new entry to the table
		fTextureLibrary.Add(t);
		returnIndex = fTextureLibrary.GetSize();
	}
	return returnIndex;
}


void Td3dDrawable::InitializeFileTextureLibrary()
{
	// For now, just create/pre-load a few file textures
	//
	CreateFileTexture("Textures/CMMR.png");				// 0
	CreateFileTexture("Textures/KelvinInOffice.png");	// 1
	CreateFileTexture("Textures/binoculars.jpg");		// 2
	CreateFileTexture("Textures/Building1.jpg");		// 3
	CreateFileTexture("Textures/Building1.jpg");		// 4  => notice this is the same as 3
	CreateFileTexture("Textures/CSSCover.jpg");			// 5

	ReplaceFileTextureAt(4, "Textures/Building2.jpg");			// Just to verify ReplaceFileTeture works ...
	ReplaceFileTextureAt(10, "Textures/edgy_promenade.jpg");	// this would cause library index to be set to 6
}